package com.njcn.advance.pojo.dto.relevent;



public class EntityGroupEvtData implements Cloneable,Comparable<EntityGroupEvtData> {
    private int node;//逻辑节点序号
    private int start_time;//事件开始时间时标
    private int cata;//类别
    private int cata2;//标注类别
    private String nodePhysics; //物理节点
    private SagEvent sagEvent;
    private String sagReason;

    public EntityGroupEvtData(String nodePhysics, int start_time, int cata, int cata2,SagEvent sagEvent,String sagReason) {
        this.nodePhysics = nodePhysics;
        this.start_time = start_time;
        this.cata = cata;
        this.cata2 = cata2;
        this.sagEvent = sagEvent;
        this.sagReason = sagReason;
    }

    public SagEvent getSagEvent() {
        return sagEvent;
    }

    public void setSagEvent(SagEvent sagEvent) {
        this.sagEvent = sagEvent;
    }

    public String getNodePhysics() {
        return nodePhysics;
    }

    public void setNodePhysics(String nodePhysics) {
        this.nodePhysics = nodePhysics;
    }

    public int getNode() {
        return node;
    }

    public void setNode(int node) {
        this.node = node;
    }

    public int getStart_time() {
        return start_time;
    }

    public void setStart_time(int start_time) {
        this.start_time = start_time;
    }

    public int getCata() {
        return cata;
    }

    public void setCata(int cata) {
        this.cata = cata;
    }

    public int getCata2() {
        return cata2;
    }

    public void setCata2(int cata2) {
        this.cata2 = cata2;
    }

    public String getSagReason() {
        return sagReason;
    }

    public void setSagReason(String sagReason) {
        this.sagReason = sagReason;
    }

    /**
     * Creates and returns a copy of this object.  The precise meaning
     * of "copy" may depend on the class of the object. The general
     * intent is that, for any object {@code x}, the expression:
     * <blockquote>
     * <pre>
     * x.clone() != x</pre></blockquote>
     * will be true, and that the expression:
     * <blockquote>
     * <pre>
     * x.clone().getClass() == x.getClass()</pre></blockquote>
     * will be {@code true}, but these are not absolute requirements.
     * While it is typically the case that:
     * <blockquote>
     * <pre>
     * x.clone().equals(x)</pre></blockquote>
     * will be {@code true}, this is not an absolute requirement.
     *
     * By convention, the returned object should be obtained by calling
     * {@code super.clone}.  If a class and all of its superclasses (except
     * {@code Object}) obey this convention, it will be the case that
     * {@code x.clone().getClass() == x.getClass()}.
     *
     * By convention, the object returned by this method should be independent
     * of this object (which is being cloned).  To achieve this independence,
     * it may be necessary to modify one or more fields of the object returned
     * by {@code super.clone} before returning it.  Typically, this means
     * copying any mutable objects that comprise the internal "deep structure"
     * of the object being cloned and replacing the references to these
     * objects with references to the copies.  If a class contains only
     * primitive fields or references to immutable objects, then it is usually
     * the case that no fields in the object returned by {@code super.clone}
     * need to be modified.
     *
     * The method {@code clone} for class {@code Object} performs a
     * specific cloning operation. First, if the class of this object does
     * not implement the interface {@code Cloneable}, then a
     * {@code CloneNotSupportedException} is thrown. Note that all arrays
     * are considered to implement the interface {@code Cloneable} and that
     * the return type of the {@code clone} method of an array type {@code T[]}
     * is {@code T[]} where T is any reference or primitive type.
     * Otherwise, this method creates a new instance of the class of this
     * object and initializes all its fields with exactly the contents of
     * the corresponding fields of this object, as if by assignment; the
     * contents of the fields are not themselves cloned. Thus, this method
     * performs a "shallow copy" of this object, not a "deep copy" operation.
     *
     * The class {@code Object} does not itself implement the interface
     * {@code Cloneable}, so calling the {@code clone} method on an object
     * whose class is {@code Object} will result in throwing an
     * exception at run time.
     *
     * @return a clone of this instance.
     * @throws CloneNotSupportedException if the object's class does not
     *                                    support the {@code Cloneable} interface. Subclasses
     *                                    that override the {@code clone} method can also
     *                                    throw this exception to indicate that an instance cannot
     *                                    be cloned.
     * @see Cloneable
     */
    @Override
    protected Object clone() throws CloneNotSupportedException {
        return super.clone();
    }

    public Object objClone() {
        try {
            return clone();
        } catch (CloneNotSupportedException e) {
            return new EntityGroupEvtData("-1", -1, -1, -1,null,null);
        }
    }

    @Override
    public String toString() {
        return "EntityGroupEvtData{" +
                "node=" + node +
                ", start_time=" + start_time +
                ", cata=" + cata +
                ", cata2=" + cata2 +
                '}';
    }

    @Override
    public int compareTo(EntityGroupEvtData obj) {
        if(this.getStart_time() < obj.getStart_time()){
            return -1;
        }else if(this.getStart_time() > obj.getStart_time()){
            return 1;
        }

        return 0;
    }
}